% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% Ph.D. Course "Cognitive CPSs: from theory to practice"
% Prof. Manuel Roveri, Prof. Cesare Alippi
% Politecnico di Milano, Italy
% March 2016
% 
% ----- "Learning in Nonstationary Environments"
% -> Example 5_A) NN Adaptation in nonstationary environmnents
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
clc;
close all;
addpath('./functions');

%Hidden node number
n_hidden_nodes = 10;

%Number of points used for training
N = 50;
%Noise standard deviation
std_dev = 0.05;

%Training data generation
Xt = 4*rand(1,N)-2; %uniform samples on [-2;2]
noise = std_dev * randn(1,N);
Yt = nonlin_fun(Xt,noise);


%% Network training

% Initializing network
neural_net = fitnet(n_hidden_nodes);

%Training network
neural_net = train(neural_net,Xt,Yt);


%% Plotting results
plot_nn_regression(@nonlin_fun,neural_net,Xt,Yt);
title('Original Regression Problem');

%% Generating new data
X_alt = 4*rand(1,N)-2; %uniform samples on [-2;2]
noise = 5E-2 * randn(1,N);
Y_alt = nonlin_fun_biased(X_alt,noise);

% Plotting results
plot_nn_regression(@nonlin_fun_biased,neural_net,X_alt,Y_alt);
hold on;
Y_est = neural_net(X_alt);
plot(X_alt,Y_est,'rx');
title('Perturbed Regression Problem -> BIAS');

%mean((Y_alt - Y_est).^2) % EVALUATE THE BIAS

%% New training
neural_net_alt = train(neural_net,X_alt,Y_alt);

%% Plotting results
plot_nn_regression(@nonlin_fun_biased,neural_net_alt,X_alt,Y_alt);
title('Regression Problem after Adaptation');
